<?php




/*

    THIS 'PROGRAM' ATTEMPTS TO CREATE  A GEOCENTRIC SUN/MOON
    COMPARISON OVERLAY USING THEIR DE405 EPHEMERIS POSITIONS
    AND COMPUTED ANGULAR DIAMETERS.

    THIS IS NOT A TRUE 'PROGRAM' IN THAT IT IS TREATED AS
    A PNG IMAGE, WHEN PROPERLY CALLED AS SUCH VIA AN HTML
    IMAGE <IMG> TAG.


   Ellipse/Arc Parameters:
   $cx      - Center of ellipse, X-coord
   $cy      - Center of ellipse, Y-coord
   $w       - Width of ellipse  ($w >= 2)
   $h       - Height of ellipse ($h >= 2 )
   $color   - Color of ellipse as a four component array with RGBA
   $start   - Starting angle of the arc, no limited range!
   $stop    - Stopping angle of the arc, no limited range!
   $start _can_ be greater than $stop!
   If any value is not in the given range, results are undefined.

   ImageSmoothArc(&$img, $cx, $cy, $w, $h, $color, $start, $stop)

*/


   include_once ('ImageSmoothArc.php');

   define ('KM_PER_AU', 149597870.700);
   define ('MI_PER_AU', 92955807.273);

// Get name of server.
   $ServerName = trim($_SERVER['SERVER_NAME']);

   $CanvasWidth  = 760;
   $CanvasHeight = 760;
   $ScaleFactor  = 1380;
   $thickness    = 1;

   $x0           = $CanvasWidth/2;
   $y0           = $CanvasHeight/2 - 00;
   $ElevAngDeg   = 90;
   $RotAngDeg    =  0;
   $e            = sin(Deg2Rad($ElevAngDeg));


// ------------------------------------------------------------
// READ ANGULAR DIAMETERS (IN DEGREES) OF SUN/MOON FROM COOKIE.

   $w = $_COOKIE['Current_Moon_Sun_OverLay'];

   list
  (
   $AngDiamMoon,
   $AngDiamSun,
   $DateString,
   $hhmmss,
   $TZhhmm,
   $dThhmmss,
   $JDTT,
   $Distkm,
   $Distmi,
   $DistAU
  ) = preg_split("[\|]", $w);

// COMPUTE SUN DISTANCE IN KILOMETERS AND MILES.
   $DistKm = Number_Format($DistAU * KM_PER_AU, 0);
   $DistMi = Number_Format($DistAU * MI_PER_AU, 0);

// FORMAT VALUES FOR TABULATION.
   $Distkm = Number_Format($Distkm, 1);
   $Distmi = Number_Format($Distmi, 1);

// DEFINE LUNAR DISK SIZE IN PIXELS.
   $xrM = $AngDiamMoon * $ScaleFactor;
   $yrM = $e * $xrM;

// DEFINE SOLAR DISK SIZE IN PIXELS.
   $xrS = $AngDiamSun * $ScaleFactor;
   $yrS = $e * $xrS;

   $img1 = ImageCreateTrueColor($CanvasWidth, $CanvasHeight);

   ImageAlphaBlending($img1, TRUE);

   $color = ImageColorAllocate($img1, 0, 0, 0);

// -------------------------------------------------------
// Define the decimal RGB values used for plotting colors.

   $black  = ImageColorAllocate($img1,   0,   0,   0);
   $maroon = ImageColorAllocate($img1, 128,   0,   0);
   $brown  = ImageColorAllocate($img1, 128,  64,   0);
   $red    = ImageColorAllocate($img1, 255,   0,   0);
   $orange = ImageColorAllocate($img1, 255, 128,   0);
   $olive  = ImageColorAllocate($img1, 128, 128,   0);
   $yellow = ImageColorAllocate($img1, 255, 255,   0);
   $green  = ImageColorAllocate($img1,   0, 255,   0);
   $cyan   = ImageColorAllocate($img1,   0, 255, 255);
   $DkCyan = ImageColorAllocate($img1,   0,  64, 128);
   $blue   = ImageColorAllocate($img1,   0,   0, 255);
   $DkBlue = ImageColorAllocate($img1,   0,   0,  84);
   $violet = ImageColorAllocate($img1, 255,   0, 255);
   $silver = ImageColorAllocate($img1, 192, 192, 192);
   $white  = ImageColorAllocate($img1, 255, 255, 255);

// COMPUTE ABSOLUTE DIFFERENCE IN SIZES IN DEG, MIN AND SEC OF ARC.
   $AngDiamDiffDeg = abs($AngDiamMoon - $AngDiamSun);
   $AngDiamDiffDMS = Deg_to_DMS($AngDiamDiffDeg, 1, '', 'd');
   $AngDiamDiffDMS = substr($AngDiamDiffDMS, -9);
   $AngDiamDiffDeg = sprintf("%1.8f", $AngDiamDiffDeg);

   $AngDiamMoon = sprintf("%1.8f", $AngDiamMoon);
   $AngDiamSun  = sprintf("%1.8f", $AngDiamSun);

// CREATE A BLANK IMAGE CANVAS.
   $CanvasColor = ImageColorAllocate($img1, 128, 255, 255);
   ImageFill($img1, 1,1, $CanvasColor);



// PRINT GRAPHICAL TEXT TO IMAGE.

/*
   $FontSize = 13;
   ImageTTFText($img1,13,0,   10,25+0,   $black,  $font, "      DE405 CURRENT GEOCENTRIC MOON/SUN SIZE COMPARISON OVERLAY TO SCALE");
   ImageTTFText($img1,$FontSize,0,   10,25+40,  $black,   $font, "Local Date  $DateString");
   ImageTTFText($img1,$FontSize,0,   10,25+60,  $black,   $font, "Local Time  $hhmmss UT");

   ImageTTFText($img1,$FontSize,0,   10,25+100, $black,   $font, "Delta T    $dThhmmss");
   ImageTTFText($img1,$FontSize,0,   10,25+120, $black,   $font, "JD TT      $JDTT");

   ImageTTFText($img1,$FontSize,0,   10,25+190, $black,   $font, "R Moon 1738.05 km");
   ImageTTFText($img1,$FontSize,0,   10,25+210, $black,   $font, "R Sun  696,000 km");


// DEFINE HORIZONTAL AND VERTICAL LENGTHS OF 1' OF ARC FOR SCALE.
   $ScaleLenX = 1/60 * $ScaleFactor;
   $ScaleLenY = 1/60 * $ScaleFactor;

// DEFINE END-POINTS OF 1 HORIZONTAL ARC MINUTE
// AND THEN DRAW IT FOR SCALE.
   $ScaleStartX = 134;
   $ScaleStartY = 167;
   $ScaleEndX   = $ScaleStartX + $ScaleLenX;
   $ScaleEndY   = $ScaleStartY;
   ImageTTFText($img1,15,0,   8,25+150, $black,   $font, "Scale 1'");
   ImageLine($img1, $ScaleStartX,$ScaleStartY+0, $ScaleEndX,$ScaleEndY+0, $black);
   ImageLine($img1, $ScaleStartX,$ScaleStartY+1, $ScaleEndX,$ScaleEndY+1, $black);
   ImageLine($img1, $ScaleStartX,$ScaleStartY+2, $ScaleEndX,$ScaleEndY+2, $black);

// DEFINE END-POINTS OF 1 VERTICAL ARC MINUTE
// AND THEN DRAW IT.
   $ScalStartX = 126;
   $ScalStartY = 168 - $ScaleLenY/2;
   $ScalEndX   = $ScalStartX;
   $ScalEndY   = 168 + $ScaleLenY/2;
   ImageLine($img1, $ScalStartX+0,$ScalStartY, $ScalEndX+0,$ScalEndY, $black);
   ImageLine($img1, $ScalStartX+1,$ScalStartY, $ScalEndX+1,$ScalEndY, $black);
   ImageLine($img1, $ScalStartX+2,$ScalStartY, $ScalEndX+2,$ScalEndY, $black);

// PRINT TEXT OUTPUT WITHIN IMAGE.
   ImageTTFText($img1,$FontSize,0, 440,25+40,  $black, $font, "Distance           Ang Diameter");
   ImageTTFText($img1,$FontSize,0, 380,25+60,  $black, $font, "MOON: $Distkm km       $AngDiamMoon&#176;");
   ImageTTFText($img1,$FontSize,0, 380,25+80,  $black, $font, "      $Distmi mi");

   ImageTTFText($img1,$FontSize,0, 380,25+120, $black, $font, " SUN: $DistAU AU     $AngDiamSun&#176;");
   ImageTTFText($img1,$FontSize,0, 380,25+140, $black, $font,  "      $DistKm km");
   ImageTTFText($img1,$FontSize,0, 380,25+160, $black, $font,  "       $DistMi mi");

   ImageTTFText($img1,$FontSize,0, 630,25+160, $black, $font,  "Difference");
   ImageTTFText($img1,$FontSize,0, 630,25+180, $black, $font,  "$AngDiamDiffDeg&#176;");
   ImageTTFText($img1,$FontSize,0, 630,25+200, $black, $font,  "$AngDiamDiffDMS");
*/




// PLOT LARGER IMAGE FIRST OVERLAID BY SMALLER IMAGE.
// OTHERWISE SMALLER IMAGE WILL AWAYS BE HIDDEN BEHIND
// THE LARGER.
   if ($AngDiamSun < $AngDiamMoon)
  {
// IF THE SOLAR DISK IS SMALLER THAN THE LUNAR DISK:
//
// FIRST DRAW THE LUNAR (DARK) DISK.
   $thickness = 1;
   ImageSmoothArc ($img1, $x0,$y0, $xrM,$yrM, array(0,0,0,0), 0, 360);
   ImageSmoothArc ($img1, $x0,$y0, $xrM-$thickness,$yrM-$thickness, array(0,0,0,0), 0, 360);

// THEN DRAW THE SMALLER YELLOW SOLAR DISK WITH A SLIGHT (33% TRANSPARENCY) DARKENING.
   $thickness = 0;
   ImageSmoothArc ($img1, $x0,$y0, $xrS,$yrS, array(0,0,0,0), 0, 360);
   ImageSmoothArc ($img1, $x0,$y0, $xrS-$thickness,$yrS-$thickness, array(255,255,0,100-33), 0, 360);
   ImageSmoothArc ($img1, $x0,$y0, 1,1, array(0,0,0,0), 0, 360); // Mark common center.
  }

else

  {
// DO THIS IF THE SOLAR DISK IS LARGER THAN THE LUNAR DISK:
//
// FIRST DRAW THE BRIGHT YELLOW SOLAR DISK.
   $thickness = 1;
   ImageSmoothArc ($img1, $x0,$y0, $xrS,$yrS, array(255,255,0,0), 0, 360);
   ImageSmoothArc ($img1, $x0,$y0, $xrS-$thickness,$yrS-$thickness, array(255,255,0,0), 0, 360);

// THEN DRAW THE SMALLER LUNAR (DARK) DISK.
   $thickness = 0;
   ImageSmoothArc ($img1, $x0,$y0, $xrM,$yrM, array(0,0,0,0), 0, 360);
   ImageSmoothArc ($img1, $x0,$y0, $xrM-$thickness,$yrM-$thickness, array(0,0,0,0), 0, 360);
   ImageSmoothArc ($img1, $x0,$y0, 1,1, array(64,64,64,0), 0, 360); // Mark the center
  }

// APPLY OPTIONAL ROTATION TO GENERATED GRAPHIC IMAGE.
   $img1 = ImageRotate ($img1, $RotAngDeg, $color);

// DEFINE FILE NAME FOR THE GENERATED PNG IMAGE.
   $w  = Str_Replace(" ", "_", "Moon-Sun Size Comparison Overlay_$DateString $hhmmss UT");
   $w  = Str_Replace(":", ".", $w);
   $ImageFileNameStr = "$w";

// GENERATE A PNG IMAGE WITH THE GIVEN FILE NAME.  WHEN CALLED
// VIA THE HTML <IMG> TAG,  THIS IS THE FILE NAME THAT WILL BE
// USED IF THE USER SAVES THE GRAPHIC.  THIS IS SIMILAR TO THE
// RETURN STATEMENT AT THE END OF A FUNCTION.  AFTER RETURNING
// THE IMAGE,  FREE-UP (DESTROY) THE LOCAL SYSTEM RESOURCES OR
// RAM USED TO CREATE IT FOR SUBSEQUENT USE BY OTHER PROCESSES.
   header("CONTENT-TYPE:image/png");
   header("CONTENT-DISPOSITION:filename=$ImageFileNameStr");
   ImagePNG($img1);
   ImageDestroy($img1);





// ---------------------------------------------------------------------------
// BELOW IS AN ATTACHED STAND-ALONE FUNCTION TO CONVERT DECIMAL DEGREES INTO
// AN EQUIVALENT DEGREES/MINUTES/SECONDS OF ARC (123 04' 05.678") STRING.

/*
   ===========================================================================
   THIS FUNCTION CONVERTS DECIMAL DEGREES TO DEGREES, MINUTES, SECONDS OF ARC.
   THE ANGULAR ELEMENTS ARE RETURNED IN A SPACE-DELIMITED STRING.

   OPTIONAL SYMBOLS ARE ATTACHED TO THE ANGLE ELEMENTS. THE SECONDS CAN BE
   OPTIONALLY ROUNDED TO UP TO 3 DECIMALS (0.001) WITH 0=DEFAULT.

   SYMBOLS MODE = TRUE|FALSE OR d|D
   TRUE|d|D MEANS TO APPLY DMS SYMBOLS TO RETURNED STRING.
   FALSE MEANS NO DMS SYMBOLS ARE APPLIED TO RETURNED STRING.

   ===========================================================================
*/

   function Deg_to_DMS ($AngDeg, $ssDecimals=0, $PosSignSymbol='', $SymbolsMode='d')
{

// Init
   $_d_ = $_m_ = $_s_ = '';

// ------------------------------------------------------
// Compute signed angular elements from decimal argument.
// This value is taken as decimal degrees.
   $sign = ($AngDeg < 0)? '-' : '';

   if (($PosSignSymbol === TRUE or $PosSignSymbol == '+') and $sign == '') {$sign = '+';}

   $degrees = abs($AngDeg);
   $dd      = floor($degrees);
   $minutes = 60*($degrees - $dd);
   $mm      = floor($minutes);
   $seconds = 60*($minutes - $mm);
   $ss      = sprintf("%1.3f", $seconds);

// ----------------------------------
// Check for that blasted 60s glitch.
   if ($ss == 60) {$ss = 0; $mm++;}
   if ($mm == 60) {$mm = 0; $dd++;}

// ----------------------------
// Format the angular elements.
   $dd = sprintf("%02d",  $dd);
   $mm = sprintf("%02d",  $mm);
   $ss = sprintf("%1.$ssDecimals" . "f", $ss);

   if ($ss < 10) {$ss = "0$ss";}

// Attach optional DMS symbols.
// Default = TRUE. Can also use 'd' for DMS symbols flag.
   if ($SymbolsMode === TRUE or substr(strtolower($SymbolsMode),0,1) == 'd')
      {
       $_d_ = "&deg;";
       $_m_ = "'";
       $_s_ = '"';
      }

// Done.
   return "$sign$dd$_d_ $mm$_m_ $ss$_s_";

} // End of  Deg_to_DMS (...)



?>


